#include "globmatc.h"
#include "globmat.h"
#include "globmatt.h"
#include "global.h"
#include "globalt.h"
#include "globalc.h"
#include "loadcase.h"
#include "element.h"
#include "elemswitch.h"
#include "elemswitcht.h"
#include "elemswitchc.h"
#include "intpoints.h"
#include "node.h"
#include "element.h"



/**
   function assembles %matrix which contains stiffness and conductivity matrices
   
   @param lcid - load case id

   JK
*/
void zero_order_matrix (long lcid)
{
  long i,mndofe,tndofe;
  ivector rcn,ccn;
  matrix lm;
  
  if (D0mat==NULL)  D0mat = new gmatrix;
    
  //  provizorni gtopologie (kombinace Gtm a Gtt)
  
  //D0mat->ts=Cp->tstord0;
  D0mat->setval (Cp->ssle);
  D0mat->initiate (Gtu,Ndofc,Cp->tstord0,Mesprc,Outc);

  
  //  mazani provizorni topologie
    
  //D0mat->setval (Cp->ssle.tlinsol,Cp->ssle.prec.pt,Cp->ssle.ni,Cp->ssle.err);
  
  //fprintf (Outc,"\n\n\n na zacatku\nMATICE VODIVOSTI (TUHOSTI) \n\n\n");
  //D0mat->printmat (Outc);
  
  //***************************************
  //  contributions from stiffness matrices
  //***************************************
  //  contributions from MEFEL part
  for (i=0;i<Mt->ne;i++){
    mndofe = Gtm->give_ndofe (i);
    
    allocm (mndofe,mndofe,lm);
    stiffmat (i,lcid,lm);
    
    allocv (mndofe,rcn);
    //rcn = new long [mndofe];
    Gtm->give_code_numbers (i,rcn.a);
    
    D0mat->localize (lm,rcn,i);
    
    destrm (lm);
    destrv (rcn);
    //delete [] rcn;
  }
  

  //fprintf (Outc,"\n\n\n mefel\nMATICE TUHOSTI \n\n\n");
  //D0mat->printmat (Outc);

  //******************************************
  //  contributions from conductivity matrices
  //******************************************
  //  contributions from TRFEL part
  for (i=0;i<Tt->ne;i++){
    tndofe = Gtt->give_ndofe (i);
    
    allocm (tndofe,tndofe,lm);
    conductmat (i,lcid,lm);
    
    allocv (tndofe,rcn);
    //rcn = new long [tndofe];
    Gtt->give_code_numbers (i,rcn.a);
    
    D0mat->localize (lm,rcn,i);
    
    destrm (lm);
    destrv (rcn);
    //delete [] rcn;
  }
    
  //fprintf (Outc,"\n\n\n trfel\nMATICE VODIVOSTI \n\n\n");
  //D0mat->printmat (Outc);

  //  contributions from METR upper part
  for (i=0;i<Ct->ne;i++){
    mndofe = Gtm->give_ndofe (i);
    tndofe = Gtt->give_ndofe (i);
    
    allocm (mndofe,tndofe,lm);
    upper_cond_coupl_mat (i,lcid,lm);
    
    allocv (mndofe,rcn);
    //rcn = new long [mndofe];
    allocv (tndofe,ccn);
    //ccn = new long [tndofe];
    Gtm->give_code_numbers (i,rcn.a);
    Gtt->give_code_numbers (i,ccn.a);
    
    D0mat->glocalize (lm,rcn,ccn);
    
    destrm (lm);
    destrv (rcn);
    //delete [] rcn;
    destrv (ccn);
    //delete [] ccn;
  }
    
  //fprintf (Outc,"\n\n\n metru\nMATICE VODIVOSTI-TUHOSTI \n\n\n");
  //D0mat->printmat (Outc);
			  
  //  contributions from METR lower part
  for (i=0;i<Ct->ne;i++){
    mndofe = Gtm->give_ndofe (i);
    tndofe = Gtt->give_ndofe (i);
    
    allocm (tndofe,mndofe,lm);
    lower_cond_coupl_mat (i,lcid,lm);
    
    allocv (tndofe,rcn);
    //rcn = new long [tndofe];
    allocv (mndofe,ccn);
    //ccn = new long [mndofe];
    Gtm->give_code_numbers (i,ccn.a);
    Gtt->give_code_numbers (i,rcn.a);
    
    D0mat->glocalize (lm,rcn,ccn);
    
    destrm (lm);
    destrv (rcn);
    //delete [] rcn;
    destrv (ccn);
    //delete [] ccn;
  }
  
  //fprintf (Outc,"\n\n\n metrl\nMATICE VODIVOSTI-TUHOSTI \n\n\n");
  //D0mat->printmat (Outc);
  
  //D0mat->prepmat (Gtu,Cp->zero,Mesprc);
  D0mat->prepmat (Cp->zero,Mesprc);
}



/**
   function assembles general capacity %matrix
   
   @param lcid - load case id

   JK
*/
void first_order_matrix (long lcid)
{
  long i,mndofe,tndofe;
  ivector rcn,ccn;
  matrix lm;

  if (D1mat==NULL)  D1mat = new gmatrix;

  //  sdruzena topologie
  //D1mat->ts=Cp->tstord1;
  D1mat->setval (Cp->ssle);
  D1mat->initiate (Gtu,Ndofc,Cp->tstord1,Mesprc,Outc);

  
  //D1mat->setval (Cp->ssle.tlinsol,Cp->ssle.prec.pt,Cp->ssle.ni,Cp->ssle.err);


  //  contributions from MEFEL part
  /* for (i=0;i<Mt->ne;i++){//pokus!!??
     mndofe = Gtm->give_ndofe (i);
     
     allocm (mndofe,mndofe,lm);
     stiffmat (i,lcid,lm);
     
     rcn = new long [mndofe];
     Gtm->give_code_numbers (i,rcn);
     
     D1mat->localize (lm,rcn,i);
     
     destrm (lm);
     delete [] rcn;
     }
  */
  
  //  contributions from TRFEL part
  for (i=0;i<Tt->ne;i++){
    tndofe = Gtt->give_ndofe (i);
    
    allocm (tndofe,tndofe,lm);
    capacmat (i,lcid,lm);
    
    allocv (tndofe,rcn);
    //rcn = new long [tndofe];
    Gtt->give_code_numbers (i,rcn.a);
    
    D1mat->localize (lm,rcn,i);

    destrm (lm);
    destrv (rcn);
    //delete [] rcn;
  }



  //  contributions from METR upper part
  for (i=0;i<Ct->ne;i++){
    mndofe = Gtm->give_ndofe (i);
    tndofe = Gtt->give_ndofe (i);
    
    allocm (mndofe,tndofe,lm);
    upper_cap_coupl_mat (i,lcid,lm);
    
    allocv (mndofe,rcn);
    //rcn = new long [mndofe];
    allocv (tndofe,ccn);
    //ccn = new long [tndofe];
    Gtm->give_code_numbers (i,rcn.a);
    Gtt->give_code_numbers (i,ccn.a);
    
    D1mat->glocalize (lm,rcn,ccn);
    
    destrm (lm);
    destrv (rcn);
    //delete [] rcn;
    destrv (ccn);
    //delete [] ccn;
  }


  //  contributions from METR lower part
  for (i=0;i<Ct->ne;i++){
    mndofe = Gtm->give_ndofe (i);
    tndofe = Gtt->give_ndofe (i);
    
    allocm (tndofe,mndofe,lm);
    lower_cap_coupl_mat (i,lcid,lm);
    
    allocv (tndofe,rcn);
    //rcn = new long [tndofe];
    allocv (mndofe,ccn);
    //ccn = new long [mndofe];
    Gtm->give_code_numbers (i,ccn.a);
    Gtt->give_code_numbers (i,rcn.a);
    
    D1mat->glocalize (lm,rcn,ccn);
    
    destrm (lm);
    destrv (rcn);
    //delete [] rcn;
    destrv (ccn);
    //delete [] ccn;
  }
  


  //D1mat->prepmat (Gtu,Cp->zero,Mesprc);
  D1mat->prepmat (Cp->zero,Mesprc);
}



/**
  The function assembles map of correspondece between 
  TRFEL and MEFEL integration points. The meshes must be identical and 
  integration order of stiffness matrix and conductivity matrix must be 
  the same. Resulting maps are stored in arrays tm_ip and mt_ip.

  @param tm_ip - trfel to mefel ip correspondence map - tm_ip[trf_ipp] = mef_ipp
  @param mt_ip - mefel to trfel ip correspondence map - mt_ip[mef_ipp] = trf_ipp

  @return The function returns maps in the tm_ip and mt_ip.

  Created by Tomas Koudelka, 11.11.2013
*/
void mefel_trfel_ip_mapping(long *tm_ip, long *mt_ip)
{
  elemtypet ett;
  long ippt, ippm;
  long iokm;
  long i, j, ii, jj, n;

  if (Mt->ne != Tt->ne)
  {
    print_err("number of elements of TRFEL(=%ld) and MEFEL(=%ld)\n meshes are not the same", 
              __FILE__, __LINE__, __func__, Tt->ne, Mt->ne);
    abort();
  }
  // TRFEL -> MEFEL ip correspondence
  // tm_ip[trf_ipp] = mefel_ipp
  for(i=0; i<Tm->tnip; i++)
    tm_ip[i] = -1;
  // MEFEL -> TRFEL ip correspondence
  // mt_ip[mef_ipp] = trfel_ipp
  for(i=0; i<Mm->tnip; i++)
    mt_ip[i] = -1;

  for(i=0; i<Tt->ne; i++)
  {
    ett = Tt->give_elem_type(i);
    switch (ett)
    {
      case barlint:
        for (ii=0;ii<Tp->ntm;ii++)
        {
          for (jj=0;jj<Tp->ntm;jj++)
          {
            ippt = Tt->elements[i].ipp[ii][jj];
            n  = Tt->give_nip(i, ii, jj);
            for(j=0; j < n; j++)
            {
              tm_ip[ippt] = Mt->elements[i].ipp[0][0];
              ippt++;
            }
          }
        }
        ippm = Mt->elements[i].ipp[0][0];
        for(j=0; j<Mt->give_tnip(i); j++)
        {
          mt_ip[ippm] = Tt->elements[i].ipp[0][0]+1;
          ippm++;
        }
        break;
      case trlint:
      case trlaxisym:
        for (ii=0;ii<Tp->ntm;ii++)
        {
          for (jj=0;jj<Tp->ntm;jj++)
          {
            ippt = Tt->elements[i].ipp[ii][jj];
            n  = Tt->give_nip(i, ii, jj);
            for(j=0; j < n; j++)
            {
              tm_ip[ippt] = Mt->elements[i].ipp[0][0];
              ippt++;
            }
          }
        }
        ippm = Mt->elements[i].ipp[0][0];
        for(j=0; j<Mt->give_tnip(i); j++)
        {
          mt_ip[ippm] = Tt->elements[i].ipp[0][0];
          ippm++;
        }
        break;
      case quadlint:
        for (ii=0;ii<Tp->ntm;ii++)
        {
          for (jj=0;jj<Tp->ntm;jj++)
          {
            ippt = Tt->elements[i].ipp[ii][jj];
            n  = Tt->give_nip(i, ii, jj);
            iokm = Tt->give_intordkm(i, ii, jj);
            for(j=0; j < n; j++)
            {
              tm_ip[ippt] = Mt->elements[i].ipp[0][0]+(j%iokm);
              ippt++;
            }
          }
        }
        ippm = Mt->elements[i].ipp[0][0];
        n = Mt->give_nip(i, 0, 0);
        for(j=0; j<n; j++)
        {
          mt_ip[ippm] = Tt->elements[i].ipp[0][0]+j;
          ippm++;
        }
        break;
      case barquadt:
      case quadquadt:
      case quadquadtax:
      case lineartett:
      case linearhext:
      case quadratichext:
        for (ii=0;ii<Tp->ntm;ii++)
        {
          for (jj=0;jj<Tp->ntm;jj++)
          {
            ippt = Tt->elements[i].ipp[ii][jj];
            n  = Tt->give_nip(i, ii, jj);
            iokm = Tt->give_intordkm(i, ii, jj);
            for(j=0; j < n; j++)
            {
              tm_ip[ippt] = Mt->elements[i].ipp[0][0]+(j%iokm);
              ippt++;
            }
          }
        }
        ippm = Mt->elements[i].ipp[0][0];
        for(j=0; j<Mt->give_tnip(i); j++)
        {
          mt_ip[ippm] = Tt->elements[i].ipp[0][0]+j;
          ippm++;
        }
        break;
      default:
        print_err("unknown element type is required", __FILE__, __LINE__, __func__);
    }
  }
}



/**
  The function transfers MEFEL quantities to TRFEL with respect to required nontransport 
  quantities in TRFEL. Meshes must be identical in TRFEL and MEFEL and
  individual quantities are copied between corresponding integration points.

  @return The function does not return anything but it changes values in the Tm->nontransq array.

  Created by Tomas Koudelka 14.11.2013
*/
void mefel_trfel_copyip(void)
{
  long i,j;
  double ipval;
  long antq[Tm->tnkntq];

  // transfer of MEFEL quantities to TRFEL
  for(i=0; i<Tm->tnip; i++)
  {
    memset(antq, 0, sizeof(*antq)*Tm->tnkntq);
    Tm->give_reqntq(i, antq); // search for required non-transport quantities on the i-th integration point

    for (j=0; j<Tm->nntq; j++)
    {
      if (antq[int(Tm->ntqo[j])-1] == 1) // the model requires j-th quantity of totally used quantities
      {  
        ipval = Mm->givemechq(Tm->ntqo[j], TM_ip[i]);
        Tm->storenontransq(Tm->ntqo[j], i, ipval);
      }
      else // the quantity is not required => store 0.0
        Tm->storenontransq(Tm->ntqo[j], i, 0.0);
    }
  }
}



/**
  The function transfers TRFEL quantities to MEFEL with respect to required nonmechanical
  quantities in MEFEL. Meshes must be identical in MEFEL and TRFEL and
  individual quantities are copied between corresponding integration points.

  @return The function does not return anything but it changes values in the Mm->nonmechq array.

  Created by Tomas Koudelka 14.11.2013
*/
void trfel_mefel_copyip(void)
{
  long i,j;
  double ipval;
  long anmq[Mm->tnknmq];

  // transfer of TRFEL quantities to MEFEL
  for(i=0; i<Mm->tnip; i++)
  {
    memset(anmq, 0, sizeof(*anmq)*Mm->tnknmq);
    for (j=0; j<Mm->ip[i].nm; j++)
      Mm->give_reqnmq(i, j, antq); // search for required non-transport quantities on the i-th integration point

    for (j=0; j<Mm->nnmq; j++)
    {
      if (anmq[int(Mm->nmqo[j])-1] == 1) // the model requires j-th quantity of totally used quantities
      {  
        if (MT_ip[i] < 0) // the fifth integration point on plelemlq
        {
          ipval  = Tm->givetransq(Mm->nmqo[j], MT_ip[i-4]);
          ipval += Tm->givetransq(Mm->nmqo[j], MT_ip[i-3]);
          ipval += Tm->givetransq(Mm->nmqo[j], MT_ip[i-2]);
          ipval += Tm->givetransq(Mm->nmqo[j], MT_ip[i-1]);
          ipval /= 4.0;
        }
        else
          ipval = Tm->givetransq(Mm->nmqo[j], MT_ip[i]);
        Mm->storenonmechq(Mm->nmqo[j], i, ipval);
      }
      else // the quantity is not required on the i-th integartion point => store 0.0
        Mm->storenonmechq(Mm->nmqo[j], i, 0.0);
    }
  }
}



/**
  The function allocates nodal arrays used in the case of passing data
  between TRFEL and MEFEL by nodal values.

  @return The function does not return anything.

  Created by Tomas Koudelka, 14.11.2013
*/
void mefel_trfel_by_nodes(void)
{
  long i, j, k, nnet, nnem, nnv, nip, ipid, nentq;
  ivector nodes;
  vector nodval, ipval, auxnv;
  long antq[Tm->tnkntq];
  nontransquant *entqo; 

  for (i=0;i<Tt->ne;i++)
  {
    if (Gtt->leso[i]==1)
    {
      
      memset(antq, 0, sizeof(*antq)*Tm->tnkntq);
      ipid=Tt->elements[i].ipp[0][0];
      for(j=0; j<Tt->give_tnip(i); j++)
      {
        Tm->give_reqntq(ipid, antq); // search for required non-transport quantities on the i-th integration point
        ipid++;
      }

      for (j=0, nentq=0; j<Tm->tnkntq; j++)
      {
        if (antq[j] == 1)   nentq++;  // compute number of required non-transport quantities on i-th element
      } 

      entqo = new nontransquant[nentq];      
      for (j=0, k=0; j<Tm->tnkntq; j++)
      {
        if (antq[j] == 1)   
          entqo[k]= nontransquant(j+1);  // assemble arrray with ordering of required non-transport quantities on element
      } 
      
      nnet = Tt->give_nne (i); // number of nodes on transport element      
      nnem = Mt->give_nne (i); // number of nodes on mechanical element
      nnv = (nnet < nnem) ? nnet : nnem; // minimum number of nodes
      reallocv (nnv*Tm->nntq,nodval);
      
      //  nodal values of all required nontransport(=mechanical) quantities on mechanical element
      elem_mechq_nodval_comp(i, nodval, nnv, nentq, entqo);

      //  interpolation of individual non-transport (mechanical) quantities      
      auxnv.n = nnet;
      nip = Tt->give_tnip (i); // number of int. points on trnasport element
      reallocv (nip,ipval);
      for (j=0; j<nentq; j++)
      { 
        auxnv.a = nodval.a + j*nnv;

        if (nnet > nnem) // TRFEL element approximation is quadratic but MEFEL is linear
        {
          // it is assumed that order of corner nodes on a quadratic element 
          // is identical with order on linear one.

          // elem_intpointvalt2 (i, auxnv, ipval);
          print_err("TRFEL element approximation order is higher than on MEFEL element", __FILE__, __LINE__, __func__);
          abort();
        }
        else
        {
          // MEFEL and TRFEL element approximation are identical =>
          // it is assumed that order of nodes on TRFEL and MEFEL elements are identical

          // MEFEL element approximation is quadratic but TRFEL is linear =>
          // nothing is necessary because it is assumed that order of corner nodes on a quadratic
          // element is identical with order on linear one.

          //  interpolation of nodal values to integration points
          elem_intpointvalt (i, auxnv, ipval);
        }
      
        //  number of the first integration point
        ipid=Tt->elements[i].ipp[0][0];
      
        for (k=0;k<nip;k++)
        {
          Tm->storenontransq(ntqo[j], ipid, ipval[k]);
          ipid++;
        }
      }
    }
  }
  auxnv.a = NULL; // avoid memory deallocation error
}



/**
   function computes %vector of generalized internal forces
   general internal force is notation of internal force or internal flux
   
   @param lcid   - load case id
   @param intfor - internal forces and fluxes

   JK, 28.7.2001
*/
void internal_gforces (long lcid,double *intfor)
{
  double *ifort,*iform;

  ifort= new double [Ndofc];
  nullv (ifort,Ndofc);
  iform= new double [Ndofc];
  nullv (iform,Ndofc);
  nullv (intfor,Ndofc);

  //  actual nodal forces MEFEL
  internal_forces (lcid,iform);
  addv (intfor,iform,Ndofc);

  //  actual nodal fluxes TRFEL
  internal_fluxes (ifort,Ndofc);
  addv (intfor,ifort,Ndofc);

  // actual nodal forces  and fluxes METR
  //internal_coup_fluxes (av,Ndofc);
  //internal_coup_forces (lcid,intfor);
  
  delete [] iform;
  delete [] ifort;
}



/**
   function computes %vector of increments of generalized internal forces
   general internal force is notation of internal force or internal flux
   
   @param lcid   - load case id
   @param intfor - increments of internal forces and fluxes

   12/9/2008, TKr
*/
void incr_internal_gforces (long lcid,double *intfor)
{
  double *ifort,*iform;

  ifort= new double [Ndofc];
  nullv (ifort,Ndofc);
  iform= new double [Ndofc];
  nullv (iform,Ndofc);
  nullv (intfor,Ndofc);
  
  //  actual increments of nodal forces MEFEL
  incr_internal_forces (lcid,iform);
  addv (intfor,iform,Ndofc);
  
  //  actual increments of nodal fluxes TRFEL
  //incr_internal_fluxes (ifort,Ndofc);
  //addv (intfor,ifort,Ndofc);

  // actual increments of nodal forces  and fluxes METR
  //incr_internal_coup_fluxes (av,Ndofc);
  //incr_internal_coup_forces (lcid,intfor);
  
  delete [] iform;
  delete [] ifort;
}



/**
   function extracts TRFEL values on one element

   @param lcid - number of load case
   @param r - vector of nodal values
   @param cn - array containing code numbers
   @param ndofe - number of DOFs on actual element

   JK, 9.7.2001
*/
void elemvaluesc (long lcid,double *r,long *cn,long ndofe)
{
  long i,ii;

  for (i=0;i<ndofe;i++){
    ii=cn[i];
    if (ii<0)   r[i]=Tb->lc[lcid].pv[0-ii-1].getval();
    if (ii==0)  r[i]=0.0;
    if (ii>0)   r[i]=Lsrst->lhsi[ii-1]+Lsrst->lhs[ii-1];
  }
}



/**
   function computes %vector of generalized right hand side
   
   @param lcid - load case id
   @param rhs - array of right hand side
   @param flv - array of load %vector caused by forces only (default value is NULL)
   
   @return The function returns assembled vectors of righ hand side and load vector caused by force.

   JK, 28.7.2001,
   Modified by Tomas Krejci 18/05/2012
*/
void metr_right_hand_side (long lcid,double *rhs,double *flv)
{
  double *av;

  av = new double [Ndofc];

  nullv (rhs,Ndofc);
  nullv (flv,Ndofc);
  nullv (av,Ndofc);

  mefel_right_hand_side (lcid,rhs,flv);//MEFEL part
  trfel_right_hand_side (lcid,av,Ndofc);//TRFEL part
  addv (rhs,av,Ndofc);
  
  nullv (av,Ndofc);
  right_hand_side (lcid,av,Ndofc);//METR part
  addv (rhs,av,Ndofc);

  delete [] av;
}



/**
   function updates material data on element int. points
   
   14/05/2010, TKr
*/
void updateval()
{
  //updating of int. points material models
  Tm->updateipval ();
  Mm->updateipval();
  Cmu->updateipval();
  //Cml->updateipval();
}



/**
   function copies coupling data
   
   14/05/2010, TKr
*/
void copy_data()
{
  if (Cp->tprob==fully_coupled_mech_trans){
    //  copying of METR data to MEFEL
    //mefel_metr ();
    //  copying of transport data to METR
    //trfel_metr ();
  }


  // transfer of MEFEL quantities to TRFEL
  //mefel_trfel_copyip();//new version 

  // transfer of TRFEL quantities to MEFEL
  //trfel_mefel_copyip();

  //  copying of transport data to MEFEL
  trfel_mefel ();
  //  copying of mechanical data to TRFEL
  mefel_trfel ();

}



/**
   function approximates data on element int. points
   
   JK, 28.7.2001
*/
void approximationc ()
{
  //  approximation of nodal values into integration points of TRFEL
  approximation ();  
  
  //  approximation of nodal values into integration points of METR
  approximationcoup ();
}



/**
   function approximates data on element int. points on coupling mesh
   
   JK, 28.7.2001
*/
void approximationcoup ()
{
  long i;
  
  switch (Cp->tmatt){
  case mech_onemedium:{
    for (i=0;i<Ct->ne;i++){
      intpointvaluesc (i);
      intpointstrainsc (i);
      intpointgradientsc (i);
    }
    break;
  }
  case mech_twomedia:{
    for (i=0;i<Ct->ne;i++){
      intpointvaluesc (i);
      intpointstrainsc (i);
      intpointgradientsc (i);
    }
    break;
  }
  case mech_threemedia:{
    for (i=0;i<Ct->ne;i++){
      intpointvaluesc (i);
      intpointstrainsc (i);
      intpointgradientsc (i);
    }
    break;
  }
  default:{
    print_err("unknown transported matter is required",__FILE__,__LINE__,__func__);
    abort();
  }
  }
  
}



/**
   function assembles %vector of coupling nodal internal fluxes and forces

   @param lcid - load case id
   @param intflux - array containing internal nodal fluxes and forces
   
   21.3.2004, TKr
*/
void internal_coup_fluxes (double *intflux,long n)
{
  long i,ne,ndofe,*cn;
  elemtypec te;
  vector lif;
  
  ne = Ct->ne;

  for (i=0;i<ne;i++){
    te = Ct->give_elem_type (i);
    ndofe = Gtt->give_ndofe (i);
    allocv (ndofe,lif);
    fillv (0.0,lif);

    cn = new long [ndofe];
    Gtt->give_code_numbers (i,cn);
    
    switch (te){
    case coupbar:{
      Cbar->res_lower_internal_fluxes (i,lif);
      break;
    }
    default:{
      fprintf (stderr,"\n\n unknown element type is required in function");
      fprintf (stderr,"\n internal_coup_fluxes (file %s, line %d).\n",__FILE__,__LINE__);
      abort ();
    }
    }
    
    locglob (intflux,lif.a,cn,ndofe);
    destrv (lif);
    delete [] cn;
    
  }
  //fluxes on boundary
  //bound_fluxes (0,intflux,n);
}



/**
   function assembles %vector of coupling nodal internal forces

   @param lcid - load case id
   @param intflux - array containing internal nodal fluxes
   
*/
void internal_coup_forces (long lcid,double *intflux)
{
  long i,ne,ndofe,*cn;
  elemtypec te;
  vector lif;
  
  ne = Ct->ne;

  for (i=0;i<ne;i++){
    te = Ct->give_elem_type (i);
    ndofe = Gtm->give_ndofe (i);//mefel ndofe
    allocv (ndofe,lif);
    fillv (0.0,lif);

    cn = new long [ndofe];
    Gtm->give_code_numbers (i,cn);//mefel cn
    
    switch (te){
    case coupbar:{
      Cbar->res_upper_internal_forces (i,lif);
      break;
    }
    default:{
      fprintf (stderr,"\n\n unknown element type is required in function");
      fprintf (stderr,"\n internal_coup_forces (file %s, line %d).\n",__FILE__,__LINE__);
      abort ();
    }
    }
    
    locglob (intflux,lif.a,cn,ndofe);
    destrv (lif);
    delete [] cn;
    
  }

  //forces on boundary
  //bound_forces (0,intflux,n);
}



/**
   function assembles coupling right hand side of the problem
   
   @param lcid - load case id
   @param rhs - array containing right hand side
   
   09.03.2004, JK+TKr
*/
void right_hand_side (long lcid,double *rhs,long n)
{
  long i,mndofe,*cn;
  vector lv;
  double *av;
  av = new double [n];
  
  assemble_init_coup_upper (rhs);

  switch (Cp->tmatt){
  case mech_onemedium:{
    nullv (av,n);
    assemble_coup (lcid,av,n);
    addv (rhs,av,n);
    break;
  }
  case mech_twomedia:{
    nullv (av,n);
    assemble_coup (lcid,av,n);
    addv (rhs,av,n);
    break;
  }
  case mech_threemedia:{
    nullv (av,n);
    assemble_coup (lcid,av,n);
    addv (rhs,av,n);
    break;
  }
  default:{
    fprintf (stderr,"\n\n unknown transported matter is required in function");
    fprintf (stderr,"\n right_hand_side (file %s, line %d).\n",__FILE__,__LINE__);
  }
  }
  
  //  contributions from volume integrals
  nullv (av,n);
  for (i=0;i<Ct->ne;i++){
    if (Gtm->leso[i]==1){
      //  only elements switched on are processed
      
      //  number of DOFs on element
      mndofe=Gtm->give_ndofe (i);
      allocv (mndofe,lv);
      fillv (0.0,lv);
      
      //  function is defined in elemswitchc.cpp
      volume_rhs_vectorc (lv,lcid,i);
      
      
      //  code numbers
      cn = new long [mndofe];
      Gtm->give_code_numbers (i,cn);
      
      //  localization of element values to the global vector
      locglob (av,lv.a,cn,mndofe);
      
      destrv (lv);
      delete [] cn;
    }  
  }  
  
  addv (rhs,av,n);
  delete [] av;
}



/**
   function assembles part of the %vector of coupling right hand side
   
   @param rhs - right hand side
   
   21.3.2004, JK+TKr
*/
void assemble_init_coup_upper (double *rhs)
{
  long i,mndofe,tndofe,lcid=0;
  long *rcn,*ccn;
  vector r,f;
  matrix km;
  
  
  for (i=0;i<Ct->ne;i++){
    mndofe = Gtm->give_ndofe (i);
    tndofe = Gtt->give_ndofe (i);
    
    allocv (tndofe,r);
    allocv (mndofe,f);
    allocm (mndofe,tndofe,km);
    
    upper_cond_coupl_mat (i,lcid,km);
    
    rcn = new long [mndofe];
    ccn = new long [tndofe];
    Gtm->give_code_numbers (i,rcn);
    Gtt->give_code_numbers (i,ccn);
    
    elemvalues (0,i,r.a,ccn,tndofe);

    mxv (km,r,f);
    cmulv (-1.0,f);
    
    locglob (rhs,f.a,rcn,mndofe);

    destrm (km);  destrv (f);  destrv (r);
    delete [] rcn;
    delete [] ccn;
  }
}



/**
   function approximates temperature computed in the TRFEL part into the MEFEL part
   
   21.6.2004, JK
*/
void approximation_temper ()
{
  long nnm;
  double *gv;
  
  //  number of nodes in MEFEL
  nnm = Mt->nn;
  
  gv = new double [nnm];
  nullv (gv,nnm);
  
  //  selection or interpolation of temperatures 
  nodal_nodal_values (gv,temperature);
  
  //  approximation of nodal data to the data at integration points
  if (Cp->lbb==quad_lin){
    intpointval2 (gv,temperature);
  }
  if (Cp->lbb==quad_quad || Cp->lbb==lin_lin){
    intpointval (gv,temperature,1.0);
  }
  
  /* 
     fprintf (Outc,"\n\n kontrola hodnot na integracnich bodech \n");
     for (long i=0;i<Mm->tnip;i++){
     fprintf (Outc,"\n point %5ld   %le",i,Mm->tempr[i]);
     }
     fprintf (Outc,"\n");
  */

  delete [] gv;
}



/**
   function approximates humidity computed in the TRFEL part into the MEFEL part
   
   22.6.2004, JK
*/
void approximation_humid ()
{
  long nnm;
  double *gv;
  
  //  number of nodes in MEFEL
  nnm = Mt->nn;
  
  gv = new double [nnm];
  nullv (gv,nnm);
  
  //  selection or interpolation of humidities
  nodal_nodal_values (gv,rel_hum);
  
  //  approximation of nodal data to the data at integration points
  if (Cp->lbb==quad_lin){
    intpointval2 (gv,rel_hum);
  }
  if (Cp->lbb==quad_quad || Cp->lbb==lin_lin){
    intpointval (gv,rel_hum,1.0);
  }
  
  delete [] gv;
}



/**
   function returns nodal values of selected quantity from the TRFEL part
   
   @param gv - array of nodal quantity, the number of components is equal to the number of nodes in MEFEL
   @param nmq - name of the value needed   

   24/8/2012, TKr
*/
void nodal_nodal_values (double *gv, nonmechquant nmq)
{
  long i,nnt,cn, idof;
  
  nnt = Tt->nn;

  switch (nmq){
    ////////////////////////////
  case temperature:{
    idof = Tp->give_var_dofid(trf_temperature);
    if (idof < 0)
    {
      print_err("temperature is not defined in the problem", __FILE__, __LINE__, __func__);
      abort();
    }
    for (i=0;i<nnt;i++)
    {
      cn=Tt->give_dof (i,idof);
      if (cn>0)  gv[i] = Lsrst->lhsi[cn-1]+Lsrst->lhs[cn-1];
      if (cn<0)  gv[i] = Tb->lc[0].pv[0-cn-1].getval();
    }
    break;
  }
    ////////////////////////////
  case initial_temperature:{
    idof = Tp->give_var_dofid(trf_temperature);
    if (idof < 0)
    {
      print_err("initial temperature is not defined in the problem", __FILE__, __LINE__, __func__);
      abort();
    }
    for (i=0;i<nnt;i++)
    {
      cn=Tt->give_dof (i,idof);
      if (cn>0)  gv[i] = Lsrst->lhsi[cn-1];
      if (cn<0)  gv[i] = Tb->lc[0].pv[0-cn-1].getval();
    }
    break;
  }
    ////////////////////////////
  case water_pressure:{
    idof = Tp->give_var_dofid(trf_water_press);
    if (idof < 0)
    {
      print_err("water pressure is not defined in the problem", __FILE__, __LINE__, __func__);
      abort();
    }
    for (i=0;i<nnt;i++)
    {
      cn=Tt->give_dof (i,idof);
      if (cn>0)  gv[i] = Lsrst->lhsi[cn-1]+Lsrst->lhs[cn-1];
      if (cn<0)  gv[i] = Tb->lc[0].pv[0-cn-1].getval();
    }
    break;
  }
  case saturation_degree:{
    //approximation degree of saturation from int. points to nodes
    give_transq_nodval (gv,nnt,nmq);
    break;
  }
    ////////////////////////////
  case suction:{
    //approximation suction from int. points to nodes
    give_transq_nodval (gv,nnt,nmq);
    break;
  }
    ////////////////////////////
  case rel_hum:{
    give_nodal_humid(gv,nnt);
    break;
  }
  case pore_pressure:{
    // water pressure + gass pressure + crystallization pressure from integration point
    // particular contributions should be scaled by degree of saturation depending 
    // on the used transport material model
    give_transq_nodval (gv,nnt,nmq);
    break;
  }
    ////////////////////////////
  default:{
    print_err("unknown type of nmq is required",__FILE__,__LINE__,__func__);
  }
  }  
}



/**
   function approximates initial temperature computed in the TRFEL part into the MEFEL part
   
   21.11.2007, JK
*/
void approximation_inittemper ()
{
  long nnm;
  double *gv;
  
  //  number of nodes in MEFEL
  nnm = Mt->nn;
  
  gv = new double [nnm];
  nullv (gv,nnm);
  
  //  selection or interpolation of temperatures 
  nodal_nodal_values (gv,initial_temperature);
  
  if (Cp->lbb==quad_quad || Cp->lbb==lin_lin){
    intpointval (gv,initial_temperature,1.0);
  }
  if (Cp->lbb==quad_lin){
    intpointval2 (gv,initial_temperature);
  }
  
  delete [] gv;
}



/**
   function exports data from METR into MEFEL
   
   05/06/2012, TKr, not completed, tady pokracovat !!!
*/
void metr_mefel ()
{
}



/**
   function exports data from MEFEL into TRFEL
   
   05/06/2012, TKr
   Modified by TKo 10.10.2013
*/
void mefel_trfel ()
{
  long i, j, k, nne, nip, ipid;
  ivector nodes;
  vector nodval, ipval;
  
  //  interpolation of individual non-transport (mechanical) quantities
  for(i=0; i<Tm->nntq; i++)
  {
    for (j=0;j<Tt->ne;j++)
    {
      if (Gtt->leso[j]==1)
      {
        nne = Tt->give_nne (j);
        nip = Tt->give_tnip (j);
      
        reallocv (nne,nodes);
        reallocv (nne,nodval);
        reallocv (nip,ipval);
      
        //  nodes on element
        Tt->give_elemnodes (j, nodes);
      
        //rozdeleni podle quad_lin apod. - tady rozmyslet!!??

        //  nodal values on mechanical element
        elem_mechq_nodval (j, nodval, Tm->ntqo[i]);
      
        //  interpolation of nodal values to integration points
        elem_intpointvalt (j, nodval, ipval);
      
        //  number of the first integration point
        ipid=Tt->elements[j].ipp[0][0];
      
        for (k=0;k<nip;k++)
        {
          Tm->storenontransq(Tm->ntqo[i], ipid, ipval[k]);
          ipid++;
        }
      }
    }
  }
}



/**
  The function exports data of TRFEL into MEFEL.
  All required non-mechanical quantities (known in TRFEL) are recalculated to 
  MEFEL integration points and stored in Mm->nonmechq.
   
   
  05/06/2012, TKr
  Modified by TKo 10.10.2013
*/
void trfel_mefel ()
{
  long i, nnm;
  double *gv;
  
  //  number of nodes in MEFEL
  nnm = Mt->nn;
  
  gv = new double [nnm];
  for (i=0; i<Mm->nnmq; i++)
  {
    if (Mm->nmqo[i] == initial_temperature)
    {
      // initial temperature can be passed only once in init_trfel_mefel()
      continue;
    }

    nullv (gv,nnm);
    //  selection or interpolation of quantity
    nodal_nodal_values (gv, Mm->nmqo[i]); // ???!!! fci casem asi presunout do TRFELu (jestli to pujde)

    if (Cp->lbb==quad_quad || Cp->lbb==lin_lin){
      intpointval(gv,Mm->nmqo[i],1.0);
    }
    if (Cp->lbb==quad_lin){
      intpointval2(gv,Mm->nmqo[i]);
    }
  }

  delete [] gv;
}



/**
  The function allocates nodal arrays used in the case of passing data
  between TRFEL and MEFEL by nodal values.

  @return The function does not return anything.

  Created by Tomas Koudelka, 9.12.2013
*/
void trfel_mefel_by_nodes(void)
{
  long i, j, k, nnet, nnem, nip, ipid, nenmq;
  ivector nodes;
  vector nodval, ipval, auxnv;
  long anmq[Mm->tnknmq];
  nonmechquant *enmqo; 
  
  for (i=0;i<Mt->ne;i++)
  {
    if (Gtm->leso[i]==1)
    {
      nnem = Mt->give_nne (i); // number of nodes on mechanical element
      nip = Mt->give_tnip (i); // number of int. points on mechanical element
      
      reallocv (nnem,nodes);
      reallocv (nnem*Mm->nnmq,nodval);
      reallocv (nip,ipval);
      
      //  nodes on element
      Mt->give_elemnodes (i, nodes);
      
      memset(anmq, 0, sizeof(*antq)*Mm->tnknmq);

      ipid=Mt->elements[i].ipp[0][0];
      for(j=0; j<Mt->give_tnip(i); j++)
      {
        for (k=0; k<Mm->ip[ipid].nm; j++)
          Mm->give_reqntq(ipid, k, anmq); // search for required non-mechanical quantities on the i-th integration point
        ipid++;
      }

      for (j=0, nenmq=0; j<Mm->tnknmq; j++)
      {
        if (anmq[j] == 1)   nenmq++;  // compute number of required non-mechanical quantities on i-th element
      } 

      enmqo = new nonmechquant[nenmq];      
      for (j=0, k=0; j<Mm->tnknmq; j++)
      {
        if (anmq[j] == 1)   
          enmqo[k]= nonmechquant(j+1);  // assemble array with ordering of required non-mechanical quantities on element
      } 

      //  nodal values of all required non-mechanical(=transport) quantities on transport element
      elem_transq_nodval_comp(i, nodval, nnem, nenmq, enmqo);

      nnet = Tt->give_nne (i); // number of nodes on transport element
      
      //  interpolation of individual non-mechanical(=transport) quantities
      auxnv.n = nnem;
      for (j=0; j<nenmq; j++)
      { 
        auxnv.a = nodval.a + j*nnem;

        if (nnem > nnet) // MEFEL element approximation is quadratic but TRFEL is linear
        {
          // it is assumed that order of corner nodes on a quadratic element 
          // is identical with order on linear one.

          elem_intpointval2 (i, auxnv, ipval);
        }
        else
        {
          // MEFEL and TRFEL element approximation are identical =>
          // it is assumed that order of nodes on TRFEL and MEFEL elements are identical

          // TRFEL element approximation is quadratic but MEFEL is linear
          // nothing is necessary because it is assumed that order of corner nodes on a quadratic
          // element is identical with order on linear one.
          
          //  interpolation of nodal values to integration points
          elem_intpointval (i, auxnv, ipval);
        }

      
        //  number of the first integration point
        ipid=Mt->elements[i].ipp[0][0];
      
        for (k=0;k<nip;k++)
        {
          Mm->storenonmechq(enmqo[j], ipid, ipval[k]);
          ipid++;
        }
      }
      delete [] enmqo;
    }
  }
  auxnv.a = NULL;
}



/**
  The function exports initial data of TRFEL into MEFEL
  Actualy, only initial temperature (known in TRFEL) is recalculated to 
  MEFEL integration points and stored in Mm->nonmechq if it is required.
   
  05/06/2012, TKr
  Modified by TKo 10.10.2013
*/
void init_trfel_mefel ()
{
  long i, nnm;
  double *gv;
  
  //  number of nodes in MEFEL
  nnm = Mt->nn;
  
  gv = new double [nnm];
  for (i=0; i<Mm->nnmq; i++)
  {
    if (Mm->nmqo[i] == initial_temperature)
    {
      // initial temperature should be passed once at the computation begining
      nullv (gv,nnm);

      //  selection or interpolation of quantity
      nodal_nodal_values (gv, Mm->nmqo[i]); // ???!!! fci casem asi presunout do TRFELu (jestli to pujde)

      if (Cp->lbb==quad_quad || Cp->lbb==lin_lin){
        intpointval (gv,Mm->nmqo[i],1.0);
      }
      if (Cp->lbb==quad_lin){
        intpointval2 (gv,Mm->nmqo[i]);
      }
    }
  }

  delete [] gv;
}
